# Magic lengths

HTLC_MAGIC_LEN = 12
HTLS_MAGIC_LEN = 8

# Tracker stuff

TRACKER_TCP_PORT = 5498
TRACKER_UDP_PORT = 5499

# Client packet types

HTLC_HDR_NEWS_GET = 0x00000065
HTLC_HDR_NEWS_POST = 0x00000067
HTLC_HDR_CHAT = 0x00000069
HTLC_HDR_LOGIN = 0x0000006B
HTLC_HDR_MSG = 0x0000006C
HTLC_HDR_KICK = 0x0000006E
HTLC_HDR_CHAT_CREATE = 0x00000070
HTLC_HDR_CHAT_INVITE = 0x00000071
HTLC_HDR_CHAT_DECLINE = 0x00000072
HTLC_HDR_CHAT_JOIN = 0x00000073
HTLC_HDR_CHAT_LEAVE = 0x00000074
HTLC_HDR_CHAT_SUBJECT = 0x00000078
HTLC_HDR_FILE_LIST = 0x000000C8
HTLC_HDR_FILE_GET = 0x000000CA
HTLC_HDR_FILE_PUT = 0x000000CB
HTLC_HDR_FILE_DELETE = 0x000000CC
HTLC_HDR_FILE_MKDIR = 0x000000CD
HTLC_HDR_FILE_GETINFO = 0x000000CE
HTLC_HDR_FILE_SETINFO = 0x000000CF
HTLC_HDR_FILE_MOVE = 0x000000D0
HTLC_HDR_FILE_ALIAS = 0x000000D1
HTLC_HDR_USER_LIST = 0x0000012C
HTLC_HDR_USER_INFO = 0x0000012F
HTLC_HDR_USER_CHANGE = 0x00000130
HTLC_HDR_ACCOUNT_CREATE = 0x0000015E
HTLC_HDR_ACCOUNT_DELETE = 0x0000015F
HTLC_HDR_ACCOUNT_READ = 0x00000160
HTLC_HDR_ACCOUNT_MODIFY = 0x00000161
HTLC_HDR_BROADCAST = 0x00000163
HTLC_HDR_PING = 0x000001F4

# Avaraline protocol additions

HTLC_HDR_ICON_LIST = 0x00000745
HTLC_HDR_ICON_SET = 0x00000746
HTLC_HDR_ICON_GET = 0x00000747
HTLC_HDR_NEWS_GET_UNFORMATTED = 0x00000865
HTLC_HDR_USER_INFO_UNFORMATTED = 0x00000870
HTLC_HDR_ACCOUNT_SELFMODIFY = 0x00000900
HTLC_HDR_PERMISSION_LIST = 0x00000901

# Server packet types

HTLS_HDR_NEWS_POST = 0x00000066
HTLS_HDR_MSG = 0x00000068
HTLS_HDR_CHAT = 0x0000006A
HTLS_HDR_CHAT_INVITE = 0x00000071
HTLS_HDR_CHAT_USER_CHANGE = 0x00000075
HTLS_HDR_CHAT_USER_LEAVE = 0x00000076
HTLS_HDR_CHAT_SUBJECT = 0x00000077
HTLS_HDR_USER_CHANGE = 0x0000012D
HTLS_HDR_USER_LEAVE = 0x0000012E
HTLS_HDR_SELFINFO = 0x00000162
HTLS_HDR_BROADCAST = 0x00000163
HTLS_HDR_TASK = 0x00010000

# Avaraline protocol additions

HTLS_HDR_ICON_CHANGE = 0x00000748

# Common data (object) types

DATA_ERROR = 0x0064
DATA_STRING = 0x0065
DATA_NICK = 0x0066
DATA_UID = 0x0067
DATA_ICON = 0x0068
DATA_LOGIN = 0x0069
DATA_PASSWORD = 0x006A
DATA_XFERID = 0x006B
DATA_XFERSIZE = 0x006C
DATA_OPTION = 0x006D
DATA_PRIVS = 0x006E
DATA_STATUS = 0x0070
DATA_BAN = 0x0071
DATA_CHATID = 0x0072
DATA_SUBJECT = 0x0073
DATA_VERSION = 0x00A0
DATA_SERVERNAME = 0x00A2
DATA_FILE = 0x00C8
DATA_FILENAME = 0x00C9
DATA_DIR = 0x00CA
DATA_RESUME = 0x00CB
DATA_XFEROPTIONS = 0x00CC
DATA_FILETYPE = 0x00CD
DATA_FILECREATOR = 0x00CE
DATA_FILESIZE = 0x00CF
DATA_DATECREATED = 0x00D0
DATA_DATEMODIFIED = 0x00D1
DATA_COMMENT = 0x00D2
DATA_NEWFILE = 0x00D3
DATA_NEWDIR = 0x00D4
DATA_USER = 0x012C

# Avaraline protocol additions

DATA_GIFICON = 0x0300
DATA_GIFLIST = 0x0301
DATA_OFFSET = 0x0319
DATA_LIMIT = 0x0320
DATA_COUNT = 0x0321
DATA_SEARCH = 0x0400
DATA_COLOR = 0x0500
DATA_POST = 0x0800
DATA_POSTID = 0x0801
DATA_PERMGROUP = 0x0850
DATA_PERM = 0x0851
DATA_IP = 0x0900

# Status bits

STATUS_AWAY = 1 << 0
STATUS_ADMIN = 1 << 1
STATUS_NOMSG = 1 << 2
STATUS_NOCHAT = 1 << 3

# Server capability flags (Avaraline addition)

CAPABILITY_NEWS = 1 << 0

# Ping types - these should not trigger unidle

PING_TYPES = (
    HTLC_HDR_PING,
    HTLC_HDR_USER_LIST,
    HTLC_HDR_USER_INFO,
    HTLC_HDR_USER_INFO_UNFORMATTED,
    HTLC_HDR_ICON_GET,
)
